import * as log4js from "log4js";
interface Logger {
    baseDir: string;
    config: LogsConfiguration;
    logDir: string;
    log4Conf: any;
}
export interface LogsConfiguration {
    saveConsoleOutput?: boolean;
    dir?: string;
    files?: {
        main?: string;
        fatal?: string;
        net?: string;
        app?: string;
    };
    options?: {
        appenders?: {
            out?: {
                type?: string;
            };
            main?: {
                type?: string;
                maxLogSize?: number;
                backups?: number;
            };
            fatal?: {
                type?: string;
                maxLogSize?: number;
                backups?: number;
            };
            errorFile?: {
                type?: string;
                maxLogSize?: number;
                backups?: number;
            };
            errors?: {
                type?: string;
                maxLogSize?: number;
                backups?: number;
            };
        };
    };
    categories?: {
        default?: {
            appenders?: string[];
            level?: string;
        };
        main?: {
            appenders?: string[];
            level?: string;
        };
        fatal?: {
            appenders?: string[];
            level?: string;
        };
    };
}
declare class Logger {
    constructor(baseDir: string, config: LogsConfiguration);
    _checkValidConfig(): void;
    _addFileNamesToAppenders(): void;
    _configureLogs(): log4js.Log4js;
    getLogger(logger: string): log4js.Logger;
    _setupLogs(): void;
    shutdown(): Promise<unknown>;
}
export declare let mainLogger: any;
export declare let historyLogger: any;
export declare let errorLogger: any;
export declare let ignoredLogger: any;
export declare function initLogger(baseDir: string, logsConfig: LogsConfiguration): void;
export default Logger;
