/// <reference types="node" />
import { Readable } from "stream";
import EventEmitter from "events";
interface Statistics {
    intervalDuration: number;
    context: any;
    counterDefs: any[];
    watcherDefs: any;
    timerDefs: {
        [name: string]: TimerRing;
    };
    manualStatDefs: any[];
    interval: NodeJS.Timeout;
    snapshotWriteFns: any[];
    stream: Readable;
    streamIsPushable: boolean;
    counters: any;
    watchers: any;
    timers: any;
    manualStats: {
        [name: string]: ManualRing;
    };
}
export declare let statisticsInstance: any;
declare class Statistics extends EventEmitter {
    constructor(baseDir: any, config: any, { counters, watchers, timers, manualStats, }: {
        counters: string[];
        watchers: any;
        timers: any;
        manualStats: string[];
    }, context: any);
    initialize(): void;
    getStream(): Readable;
    writeOnSnapshot(writeFn: any, context: any): void;
    startSnapshots(): void;
    stopSnapshots(): void;
    incrementCounter(counterName: any): void;
    setManualStat(manualStatName: any, value: any): void;
    getCurrentCount(counterName: any): any;
    getCounterTotal(counterName: any): any;
    getWatcherValue(watcherName: any): any;
    startTimer(timerName: any, id: any): void;
    stopTimer(timerName: any, id: any): void;
    getAverage(name: any): any;
    getMultiStatReport(name: any): any;
    getPreviousElement(name: any): any;
    _initializeCounters(counterDefs: any): {};
    _initializeWatchers(watcherDefs: any, context: any): {};
    _initializeTimers(timerDefs: any): {};
    _initializeManualStats(counterDefs: any): {};
    _takeSnapshot(): void;
    _pushToStream(data: any): void;
}
interface Ring {
    elements: any[];
    index: number;
}
declare class Ring {
    constructor(length: any);
    multiStats(): {
        min: number;
        max: number;
        avg: number;
        allVals: any[];
    };
    save(value: any): void;
    average(): number;
    previous(): any;
}
interface TimerRing {
    ids: any;
    ring: Ring;
}
declare class TimerRing {
    constructor(length: any);
    start(id: any): void;
    stop(id: any): void;
    snapshot(): void;
}
interface ManualRing {
    ring: Ring;
}
declare class ManualRing {
    constructor(length: any);
    manualSetValue(value: any): void;
    snapshot(): void;
}
export default Statistics;
