"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const validateReport = require("../middleware/validateReport");
const Logger = require("../class/logger");
const heartbeat = (req, res, next) => {
    try {
        const nodeId = req.body.nodeId;
        const data = req.body.data;
        const isReportValid = validateReport(data);
        if (!isReportValid)
            Logger.errorLogger.error("Report is invalid", nodeId, data);
        if (nodeId && isReportValid && data.nodeIpInfo && data.currentLoad) {
            let Node = global.node;
            Node.heartbeat(nodeId, data);
            let resp = {
                received: true,
            };
            res.status(200).send(resp);
        }
        else {
            let resp = {
                received: false,
            };
            res.status(400).send(resp);
        }
    }
    catch (e) {
        Logger.mainLogger.error(e);
        res.status(500).send('');
    }
};
module.exports = heartbeat;
//# sourceMappingURL=heartbeat.js.map